Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.basex.query.expr
Class FLWOR

    java.lang.Object
      org.basex.query.ExprInfo
          org.basex.query.expr.Expr
              org.basex.query.expr.FLWOR

Direct Known Subclasses:
  FLWR

    public class FLWOR

extends Expr

FLWOR clause.

Author:
  Workgroup DBIS, University of Konstanz 2005-09, ISC License, Christian Gruen

Nested Class Summary

Nested classes/interfaces inherited from class org.basex.query.expr.Expr
`Expr.Use`

Constructor Summary
`FLWOR(ForLet[] f, Expr w, Order o, Expr r)` Constructor.
`FLWOR(ForLet[] f, Expr w, Order o, Group g, Expr r)` FLWOR initialization.

Method Summary
`java.lang.String` | `color()` Returns a color string for the expression.
`Expr` | `comp(QueryContext ctx)` Optimizes and compiles the expression.
`Iter` | `iter(QueryContext ctx)` Evaluates the expression and returns an iterator on the resulting items.
`void` | `plan(Serializer ser)` Recursively sends the abstract syntax of this expression to the specified serializer.
`boolean` | `removable(Var v, QueryContext ctx)` Checks if the specified variable is removable.
`Expr` | `remove(Var v)` Removes the specified variable in a sub expression.
`Return` | `returned(QueryContext ctx)` Indicates the return type of an expression.
`java.lang.String` | `toString()`
`boolean` | `uses(Expr.Use u, QueryContext ctx)` Indicates if an expression uses the specified type.

Methods inherited from class org.basex.query.expr.Expr
`addText, atomic, checkCtx, checkDbl, checkItr, duplicates, e, ebv, i, indexAccessible, indexEquivalent, sameAs, size, test`

Methods inherited from class org.basex.query.ExprInfo
`info, name`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FLWOR

    public FLWOR(ForLet[] f,
                 Expr w,
                 Order o,
                 Expr r)

  Constructor.

  Parameters:
    `f` - variable inputs
    `w` - where clause
    `o` - order expressions
    `r` - return expression

### FLWOR

    public FLWOR(ForLet[] f,
                 Expr w,
                 Order o,
                 Group g,
                 Expr r)

  FLWOR initialization.

  Parameters:
    `f` - variable inputs
    `w` - where clause
    `o` - order expression
    `g` - group by expression
    `r` - return expression

Method Detail

### comp

    public Expr comp(QueryContext ctx)
              throws QueryException

  Description copied from class: `Expr`
  Optimizes and compiles the expression.

  Specified by:
    `comp` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    optimized Expression
  Throws:
    `QueryException` - query exception

### iter

    public Iter iter(QueryContext ctx)
              throws QueryException

  Description copied from class: `Expr`
  Evaluates the expression and returns an iterator on the resulting items. If this method is not overwritten, `Expr.atomic(org.basex.query.QueryContext)` must be implemented.

  Overrides:
    `iter` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    resulting item
  Throws:
    `QueryException` - query exception

### uses

    public boolean uses(Expr.Use u,
                        QueryContext ctx)

  Description copied from class: `Expr`
  Indicates if an expression uses the specified type. Called by the compiler to perform certain optimizations. `true` is returned by default and thus assumed as "worst-case".

  Specified by:
    `uses` in class `Expr`
  Parameters:
    `u` - use type to be checked
    `ctx` - query context
  Returns:
    result of check

### removable

    public boolean removable(Var v,
                             QueryContext ctx)

  Description copied from class: `Expr`
  Checks if the specified variable is removable.

  Overrides:
    `removable` in class `Expr`
  Parameters:
    `v` - variable to be removed
    `ctx` - query context
  Returns:
    result of check

### remove

    public Expr remove(Var v)

  Description copied from class: `Expr`
  Removes the specified variable in a sub expression.

  Overrides:
    `remove` in class `Expr`
  Parameters:
    `v` - variable to be removed
  Returns:
    expression with removed variable

### returned

    public Return returned(QueryContext ctx)

  Description copied from class: `Expr`
  Indicates the return type of an expression. Called by the compiler to check if expressions can be reformulated. null is returned by default.

  Overrides:
    `returned` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    result of check

### color

    public final java.lang.String color()

  Description copied from class: `ExprInfo`
  Returns a color string for the expression.

  Overrides:
    `color` in class `ExprInfo`
  Returns:
    color

### plan

    public final void plan(Serializer ser)
                    throws java.io.IOException

  Description copied from class: `ExprInfo`
  Recursively sends the abstract syntax of this expression to the specified serializer.

  Specified by:
    `plan` in class `ExprInfo`
  Parameters:
    `ser` - serializer
  Throws:
    `java.io.IOException` - I/O exception

### toString

    public final java.lang.String toString()

  Specified by:
    `toString` in class `ExprInfo`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD